#include <stdlib.h>
//#include <stdio.h>
#include "gpc.h"
#include "jwgpc.h"

//#define DBG(message, value) fprintf(stderr, message, value);fflush(stderr)
#define DBG(message, value)
/*static gpc_polygon * create_polygon(jsize fullarraysize, jdouble * input)
{
    int nVertices=fullarraysize/2;
    int i=0,ii=0;
    gpc_polygon * respoly = malloc(sizeof(gpc_polygon));
    respoly->num_contours=1;
    respoly->hole=malloc(sizeof(int));
    *(respoly->hole)=0;
    respoly->contour=malloc(sizeof(gpc_vertex_list));
    respoly->contour->num_vertices=nVertices;
    respoly->contour->vertex=malloc(nVertices*sizeof(gpc_vertex));
    for(i=0, ii=0; i<nVertices; i++){
        respoly->contour->vertex[i].x=input[ii++];
        respoly->contour->vertex[i].y=input[ii++];
    }
    return respoly;    
}*/
static gpc_polygon * create_polygon(JNIEnv * env, jobjectArray ja)
{
    int i,j,jj;
    int nCurrVertices;
    jdouble * elements;
    gpc_polygon * respoly = malloc(sizeof(gpc_polygon));
    respoly->num_contours=(*env)->GetArrayLength(env, ja);
    DBG("creating polygon, %d contours\n",respoly->num_contours);
    respoly->hole=malloc(sizeof(int));
    *(respoly->hole)=0;

    //localArrayCopy=malloc(m*sizeof(double *));
    //jsize n;
    respoly->contour=malloc(respoly->num_contours*sizeof(gpc_vertex_list));
    for(i=0; i<respoly->num_contours; i++) {
         jdoubleArray oneDim=
            (jdoubleArray)(*env)->GetObjectArrayElement(env,
                                 ja, i);         
         nCurrVertices=(*env)->GetArrayLength(env, oneDim)/2;
         respoly->contour[i].num_vertices=nCurrVertices;
         respoly->contour[i].vertex=malloc(nCurrVertices*sizeof(gpc_vertex));
         elements=(*env)->GetDoubleArrayElements(env,oneDim, 0);
         for(j=0, jj=0; j<nCurrVertices; j++){
            respoly->contour[i].vertex[j].x=elements[jj++];
            respoly->contour[i].vertex[j].y=elements[jj++];
         }
    }
    return respoly;
}
/*static void dump_polygon(FILE * output, gpc_polygon * inp_poly)
{
    int i;
    fprintf(output, "polygon has %d contours\n",inp_poly->num_contours);
    for(i=inp_poly->num_contours-1;i>=0;i--){
        fprintf(output, "c%d: %d vertices\n",i,inp_poly->contour[i].num_vertices);
    }
}*/
static void free_polygon(gpc_polygon * inp_poly)
{
    int i;
    for(i=inp_poly->num_contours-1;i>=0;i--){
        free(inp_poly->contour[i].vertex);
    }
    free(inp_poly->contour);
    free(inp_poly->hole);
    free(inp_poly);
}
/*
static void free_polygon(gpc_polygon * inp_poly)
{
    free(inp_poly->contour->vertex);
    free(inp_poly->contour);
    free(inp_poly);
}*/
JNIEXPORT jdouble JNICALL Java_jwgpc_jwgpc_jwgpc_1test
  (JNIEnv * env, jobject obj, jdoubleArray ja)
{
    static double acc=0;
    int i;
    jsize n = (*env)->GetArrayLength(env, ja);
    jdouble *a = (*env)->GetDoubleArrayElements(env, ja, 0);
    for(i=n; i>=0; i--) acc+=a[i];
    return acc;
}

JNIEXPORT jobjectArray JNICALL Java_jwgpc_jwgpc_jwgpc_1testReverse
  (JNIEnv * env, jobject obj, jobjectArray ja)
{
    jobjectArray ret;
    int i,j;
    int * rowSize;
    double ** localArrayCopy;
    jsize m = (*env)->GetArrayLength(env, ja);
    localArrayCopy=malloc(m*sizeof(double *));
    rowSize=malloc(m*sizeof(int));
    jsize n;
    for(i=0; i<m; i++) {
         jdoubleArray oneDim=
            (jdoubleArray)(*env)->GetObjectArrayElement(env,
                                 ja, i);
         n=(*env)->GetArrayLength(env, oneDim);
         localArrayCopy[i]=malloc(n*sizeof(double));
         rowSize[i]=n;
         jdouble *element=(*env)->GetDoubleArrayElements(env,oneDim, 0);
         for(j=0; j<n; j++) {
            localArrayCopy[i][j]= element[j];
         }
    }

     jdoubleArray row= (jdoubleArray)(*env)->NewDoubleArray(env,10);
     ret=(jobjectArray)(*env)->NewObjectArray(env,
	m, (*env)->GetObjectClass(env,row), 0);

     for(j=0,i=m-1;i>=0;i--,j++) {
        row= (jdoubleArray)(*env)->NewDoubleArray(env,rowSize[j]);
        (*env)->SetDoubleArrayRegion(env,(jdoubleArray)row,(
            jsize)0,rowSize[j],(jdouble *)localArrayCopy[j]);
        (*env)->SetObjectArrayElement(env,ret,i,row);
     }
    return ret;
}

JNIEXPORT jobjectArray JNICALL Java_jwgpc_jwgpc_jwgpc_1polygon_1clip
  (JNIEnv * env, jobject obj, jint set_operation, jobjectArray jsubject_polygon, jobjectArray jclip_polygon)
{
    gpc_op op=(gpc_op) set_operation;
    gpc_polygon * result_polygon=malloc(sizeof(gpc_polygon));
    jobjectArray ret;
    double * res;
    int nCurrVertices,i,j,jj;
    gpc_polygon * subject_polygon = create_polygon(env,jsubject_polygon);
//    dump_polygon(stdout,subject_polygon);
    gpc_polygon * clip_polygon = create_polygon(env,jclip_polygon);
//    dump_polygon(stdout,clip_polygon);
    DBG("clipping starts\n",0);
    gpc_polygon_clip (op, subject_polygon, clip_polygon, result_polygon);
    DBG("result polygon has %d contours\n",result_polygon->num_contours);
    jdoubleArray row= (jdoubleArray)(*env)->NewDoubleArray(env,10);
    ret=(jobjectArray)(*env)->NewObjectArray(env,
	result_polygon->num_contours, (*env)->GetObjectClass(env,row), 0);
    for(i=0; i<result_polygon->num_contours; i++) {
        nCurrVertices=result_polygon->contour[i].num_vertices;
        res=malloc(nCurrVertices*2*sizeof(double));
        for(j=0, jj=0; j<nCurrVertices; j++){
            res[jj++]=result_polygon->contour[i].vertex[j].x;
            res[jj++]=result_polygon->contour[i].vertex[j].y;
        }
        row= (jdoubleArray)(*env)->NewDoubleArray(env,2*nCurrVertices);
        (*env)->SetDoubleArrayRegion(env,(jdoubleArray)row,(
            jsize)0,2*nCurrVertices,(jdouble *)res);
        (*env)->SetObjectArrayElement(env,ret,i,row);
    }
    free_polygon(subject_polygon);
    free_polygon(clip_polygon);
    free_polygon(result_polygon);
    return ret;
}
/*
JNIEXPORT jdoubleArray JNICALL Java_jwgpc_jwgpc_jwgpc_1polygon_1clip
  (JNIEnv * env, jobject obj, jint set_operation, jdoubleArray jsubject_polygon, jdoubleArray jclip_polygon)
{
    gpc_op op=(gpc_op) set_operation;
    gpc_polygon * result_polygon=malloc(sizeof(gpc_polygon));
    jdoubleArray doubleArray;
    double * res;
    int nVertices,i, ii; 
    gpc_polygon * subject_polygon = create_polygon(
            (*env)->GetArrayLength(env,jsubject_polygon),
            (*env)->GetDoubleArrayElements(env, jsubject_polygon, 0));
    gpc_polygon * clip_polygon = create_polygon(
            (*env)->GetArrayLength(env,jclip_polygon),
            (*env)->GetDoubleArrayElements(env, jclip_polygon, 0));
    gpc_polygon_clip (op, subject_polygon, clip_polygon, result_polygon);
    nVertices=result_polygon->contour->num_vertices;
    res=malloc(nVertices*2*sizeof(double));
    for(i=0, ii=0; i<nVertices; i++){
        res[ii++]=result_polygon->contour->vertex[i].x;
        res[ii++]=result_polygon->contour->vertex[i].y;
    }        
    doubleArray = (*env)->NewDoubleArray(env, 2*nVertices);
    (*env)->SetDoubleArrayRegion( env, doubleArray, 0, 2*nVertices, (const jdouble*) res );
    free_polygon(subject_polygon);
    free_polygon(clip_polygon);
    free_polygon(result_polygon);
    return doubleArray;
}
*/
